package raytracer.tracers;
import raytracer.utilities.RGBColor;
import raytracer.utilities.Ray;
import raytracer.world.World;

//Copyright (C) Helen Hu 2011.
//based on C++ code from Ray Tracing from the Ground Up, by Kevin Suffern 
//This Java code is for non-commercial purposes only.
//This Java code is licensed under the GNU General Public License Version 2.
//See the file COPYING.txt for the full license.

//This is the declaration of the base class Tracer
//The tracer classes have no copy constructor or assignment operator because 
//of the world pointer, which should not be assigned or copy constructed
//See comments in World.java

public abstract class Tracer {
	protected World world_ptr;
	

	// -------------------------------------------------------------------- default constructor

	public Tracer() {
		world_ptr = null;
	}


	// -------------------------------------------------------------------- constructor

	public Tracer(World worldPtr){
		world_ptr = worldPtr;
	}


	// -------------------------------------------------------------------- trace_ray

	public abstract RGBColor trace_ray(Ray ray);


	// -------------------------------------------------------------------- trace_ray

	public abstract RGBColor trace_ray(Ray ray, int depth);

	
}
